
Foreman - Feature #2116

Use MCollective to trigger Puppet runs

01/08/2013 04:06 AM - Dominic Cleal

Status: Closed   

Priority: Normal   

Assignee: Dominic Cleal   

Category: Puppet integration   

Target version: 1.2.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Much requested feature from the Foreman 1.1: what do you want to see next? thread.

Puppet run/kick is deprecated from Puppet 3.x and MCollective is recommended instead.  Foreman should support using MCollective

to execute the puppetd agent (runonce action) on the host.

Related issues:

Related to Foreman - Bug #2065: Puppetrun doesn't work in Puppet version > 3.x Resolved 12/20/2012

Associated revisions

Revision 80f8a61f - 05/10/2013 12:21 PM - Sam Kottler

fixes #2116 - mcollective support for the proxy to initialize puppetrun

History

#1 - 01/08/2013 04:31 AM - Dominic Cleal

Christian McHugh implemented this by shelling out to mco: http://pastebin.com/1U8ibyrt

I think we should probably use the mco library, e.g. http://docs.puppetlabs.com/mcollective/simplerpc/clients.html, probably via the proxy for

consistency.

#2 - 01/08/2013 04:36 AM - Ohad Levy

- Assignee deleted (Ohad Levy)

it seems i had a really old branch too at https://github.com/ohadlevy/smart-proxy/tree/mc

#3 - 01/18/2013 11:31 AM - Sam Kottler

- Status changed from New to Assigned

- Assignee set to Sam Kottler

#4 - 02/11/2013 04:53 PM - Nikolay Georgieff

I have a workaround for foreman-proxy to use Mcollective:

[root@puppet proxy]# diff puppet.rb.orig puppet.rb

23c23

<       command = %x[#{sudo} #{puppetrun} --host #{hosts.join(" --host ")}]

---

command = %x[#{sudo} /usr/bin/mco puppet runonce -I #{hosts.join(" --host ")}]

#5 - 02/11/2013 06:59 PM - Sam Kottler

Yep, there is a patch that I'm working on refactoring right now that does something not too dissimilar to that.
http://groups.google.com/group/foreman-users/browse_thread/thread/482eab937d75bcfb
http://pastebin.com/1U8ibyrt
http://docs.puppetlabs.com/mcollective/simplerpc/clients.html
https://github.com/ohadlevy/smart-proxy/tree/mc


#6 - 05/09/2013 05:01 PM - Mark Heily

- File use_mco_instead_of_puppetrun_v2.patch added

The 'puppetd' MCollective plugin is deprecated, and has been replaced by the 'puppet' plugin. We need to support both plugins. I've attached a patch

that works for me.

#7 - 05/09/2013 05:31 PM - Mark Heily

- File use_mco_instead_of_puppetrun_v3.patch added

Attaching a new version of the patch with a one-line change to use escape_for_shell() when running mco.

#8 - 05/10/2013 12:27 PM - Dominic Cleal

- Status changed from Assigned to Ready For Testing

- Assignee changed from Sam Kottler to Dominic Cleal

- Target version set to 1.2.0

https://github.com/theforeman/smart-proxy/pull/78

#9 - 05/11/2013 02:26 AM - Sam Kottler

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset commit:"80f8a61f43504ec3a4753dda2ef201483e5ce855".

Files

use_mco_instead_of_puppetrun_v2.patch 3.02 KB 05/09/2013 Mark Heily

use_mco_instead_of_puppetrun_v3.patch 3.04 KB 05/09/2013 Mark Heily
